HDU2795 Billboard(线段树)

来源:互联网 发布:二战日本ISIS知乎 编辑:程序博客网 时间:2024/04/28 06:02
BillboardTime Limit: 20000/8000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)Total Submission(s): 20022    Accepted Submission(s): 8362Problem DescriptionAt the entrance to the university, there is a huge rectangular billboard of size h*w (h is its height and w is its width). The board is the place where all possible announcements are posted: nearest programming competitions, changes in the dining room menu, and other important information.On September 1, the billboard was empty. One by one, the announcements started being put on the billboard.Each announcement is a stripe of paper of unit height. More specifically, the i-th announcement is a rectangle of size 1 * wi.When someone puts a new announcement on the billboard, she would always choose the topmost possible position for the announcement. Among all possible topmost positions she would always choose the leftmost one.If there is no valid location for a new announcement, it is not put on the billboard (that's why some programming contests have no participants from this university).Given the sizes of the billboard and the announcements, your task is to find the numbers of rows in which the announcements are placed.InputThere are multiple cases (no more than 40 cases).The first line of the input file contains three integer numbers, h, w, and n (1 <= h,w <= 10^9; 1 <= n <= 200,000) - the dimensions of the billboard and the number of announcements.Each of the next n lines contains an integer number wi (1 <= wi <= 10^9) - the width of i-th announcement.OutputFor each announcement (in the order they are given in the input file) output one number - the number of the row in which this announcement is placed. Rows are numbered from 1 to h, starting with the top row. If an announcement can't be put on the billboard, output "-1" for this announcement.Sample Input3 5 524333Sample Output1213-1Authorhhanger@zjuSourceHDOJ 2009 Summer Exercise(5
怎么说,可以算新姿势吧。线段树,找到第一个大于等于所给定值的点.这道题的题意就是说,在一个高为h,宽为w的布告栏,我们要找到第一个可以贴高为1,宽为wi的小纸条,这样子我们就用线段树找到第一个大于等于wi的布告栏,更新该行的剩余空间,并返回该布告栏的行数。这里注意h的范围在10^9以内,可以h就代表行数,可是h的范围太大,h数据一大远超所定的数组范围,怎么解决呢,其实我们就可以注意一句话就是布告贴在所有可以贴的位置的最左边也就是第一个,还有就是n的范围在20w以内,我们就要从这里入手了,如果wi超过当前最大值w也就sum[1],我们就直接返回-1,而且n只有20万,所以说呢,如果给你贴20万张(排除超过w的),我们最多也就20张行的布告栏都贴满,如果给你的h超过20w的话,其实超出的部分行数是基本没有用到的,所以我们根本就不需要关心他,我们我们只要开到20w就行,那么这里我们就需要找min(h,n)(h是布告栏的高度,n是贴的布告的数量)在建数就行了。
    #include<iostream>    #include<cstring>    #include<cstdlib>    #include<algorithm>    #include<cctype>    #include<cmath>    #include<ctime>    #include<string>    #include<stack>    #include<deque>    #include<queue>    #include<list>    #include<set>    #include<map>    #include<cstdio>    #include<limits.h>    #define MOD 1000000007    #define fir first    #define sec second    #define fin freopen("/home/ostreambaba/文档/input.txt", "r", stdin)    #define fout freopen("/home/ostreambaba/文档/output.txt", "w", stdout)    #define mes(x, m) memset(x, m, sizeof(x))    #define Pii pair<int, int>    #define Pll pair<ll, ll>    #define INF 1e9+7    #define Pi 4.0*atan(1.0)    #define lowbit(x) (x&(-x))    #define lson l,m,rt<<1    #define rson m+1,r,rt<<1|1    typedef long long ll;    typedef unsigned long long ull;    const double eps = 1e-12;    const int maxn = 200010;    using namespace std;    inline int read(){        int x(0),f(1);        char ch=getchar();        while (ch<'0'||ch>'9') {if (ch=='-') f=-1;ch=getchar();}        while (ch>='0'&&ch<='9') x=x*10+ch-'0',ch=getchar();        return x*f;    }    int k;    int sum[maxn<<2];    int lain[maxn<<2];      inline void PushUp(int rt)    {        sum[rt]=max(sum[rt<<1],sum[rt<<1|1]);    }    inline void buildTree(int wi,int l,int r,int rt)    {        if(l==r){               sum[rt]=wi;            lain[rt]=++k;            return;        }        int m=(l+r)>>1;        buildTree(wi,lson);        buildTree(wi,rson);        PushUp(rt);     }    inline int update(int wi,int l,int r,int rt)    {        if(wi>sum[1]){            return -1;        }           if(l==r){            sum[rt]-=wi;            return lain[rt];        }        int m=(l+r)>>1;        int res=-1;         if(sum[rt<<1]>=wi){            res=update(wi,lson);        }        else if(sum[rt<<1|1]>=wi){            res=update(wi,rson);            }        PushUp(rt);        return res;     }    int main()    {        int h,w,n,t;        while(~scanf("%d%d%d",&h,&w,&n)){            k=0;            int mi=min(h,n);                //int mi=h;             buildTree(w,1,mi,1);            for(int i=1;i<=n;++i){                t=read();                printf("%d\n",update(t,1,mi,1));                }        }           return 0;    }
second:
#include<iostream>#include<cstring>#include<cstdlib>#include<algorithm>#include<cctype>#include<cmath>#include<ctime>#include<string>#include<stack>#include<deque>#include<queue>#include<list>#include<set>#include<map>#include<cstdio>#include<limits.h>#define MOD 1000000007#define fir first#define sec second#define fin freopen("/home/ostreambaba/文档/input.txt", "r", stdin)#define fout freopen("/home/ostreambaba/文档/output.txt", "w", stdout)#define mes(x, m) memset(x, m, sizeof(x))#define Pii pair<int, int>#define Pll pair<ll, ll>#define INF 1e9+7#define Pi 4.0*atan(1.0)#define lowbit(x) (x&(-x))#define lson l,m,rt<<1#define rson m+1,r,rt<<1|1typedef long long ll;typedef unsigned long long ull;const double eps = 1e-12;const int maxn = 200010;using namespace std;inline int read(){int x(0),f(1);char ch=getchar();while (ch<'0'||ch>'9') {if (ch=='-') f=-1;ch=getchar();}while (ch>='0'&&ch<='9') x=x*10+ch-'0',ch=getchar();return x*f;}int k;int sum[maxn<<2];int lain[maxn<<2];  inline void PushUp(int rt){    sum[rt]=max(sum[rt<<1],sum[rt<<1|1]);}inline void buildTree(int wi,int l,int r,int rt){    sum[rt]=wi;     if(l==r){          return;    }    int m=(l+r)>>1;    buildTree(wi,lson);    buildTree(wi,rson);    PushUp(rt); }inline int update(int wi,int l,int r,int rt){    if(l==r){        sum[rt]-=wi;        return l;    }    int m=(l+r)>>1;    int res=(sum[rt<<1]>=wi)?update(wi,lson):update(wi,rson);    PushUp(rt);    return res; }int main(){    int h,w,n,t;    while(~scanf("%d%d%d",&h,&w,&n)){        k=0;        int mi=min(h,n);            //int mi=h;         buildTree(w,1,mi,1);        for(int i=1;i<=n;++i){            t=read();            if(t>sum[1]){                printf("-1\n");            }            else{                 printf("%d\n",update(t,1,mi,1));            }           }    }       return 0;} 
0 0
原创粉丝点击